<?php
defined('_JEXEC') or die('Restricted access');

class pm_mellat extends PaymentRoot{
    
    function showPaymentForm($params, $pmconfigs){
        include(dirname(__FILE__)."/paymentform.php");
    }

	//function call in admin
	function showAdminFormParams($params){
	  $array_params = array('terminal', 'muser', 'mpass', 'transaction_end_status', 'transaction_pending_status', 'transaction_failed_status');
	  foreach ($array_params as $key){
	  	if (!isset($params[$key])) $params[$key] = '';
	  } 
	  $orders = &JModel::getInstance('orders', 'JshoppingModel'); //admin model
      include(dirname(__FILE__)."/adminparamsform.php");	  
	}

	function checkTransaction($pmconfigs, $order, $act){
	$jshopConfig = &JSFactory::getConfig();
	include_once('lib/nusoap.php');
    $client = new nusoap_client('https://pgws.bpm.bankmellat.ir/pgwchannel/services/pgw?wsdl');
    $namespace='http://interfaces.core.sw.bps.com/';
	$res = $_POST['ResCode'];
    $tar= $_POST['SaleReferenceId'];
	if ($res == '0') {

        $terminalId = $pmconfigs['terminal'];
		$userName =$pmconfigs['muser'];
		$userPassword = $mpass = $pmconfigs['mpass'];
		$orderId = $_POST['SaleOrderId'];
		$verifySaleOrderId = $_POST['SaleOrderId'];
		$verifySaleReferenceId = $_POST['SaleReferenceId'];
		
		
		// Check for an error
		$err = $client->getError();
		if ($err) {
			echo '<h2>Constructor error</h2><pre>' . $err . '</pre>';
			return array(0, 'مشکلی در تراکنش بوجود آمده است.');
		}
	  	  
		$parameters = array(
			'terminalId' => $terminalId,
			'userName' => $userName,
			'userPassword' => $userPassword,
			'orderId' => $orderId,
			'saleOrderId' => $verifySaleOrderId,
			'saleReferenceId' => $verifySaleReferenceId);

		// Call the SOAP method
		$result = $client->call('bpVerifyRequest', $parameters, $namespace);

				// Check for a fault
		if ($client->fault) {
			echo '<h2>Fault</h2><pre>';
			print_r($result);
			echo '</pre>';
			return array(0, 'مشکلی در تراکنش بوجود آمده است.');
		} 
		else {

			$resultStr = $result;
			
			$err = $client->getError();
			if ($err) {
				// Display the error
				echo '<h2>Error</h2><pre>' . $err . '</pre>';
				return array(0, 'مشکلی در تراکنش بوجود آمده است.');
			} 
			else {
				// Display the result
				// Update Table, Save Verify Status 
				// Note: Successful Verify means complete successful sale was done.
				
			}// end Display the result
		}// end Check for errors
        $terminalId = $pmconfigs['terminal'];
		$userName =$pmconfigs['muser'];
		$userPassword = $pmconfigs['mpass'];
		
		$orderId =  $_POST['SaleOrderId'];
		$settleSaleOrderId =  $_POST['SaleOrderId'];
		$settleSaleReferenceId =  $_POST['SaleReferenceId'];

		// Check for an error
		$err = $client->getError();
		if ($err) {
			echo '<h2>Constructor error</h2><pre>' . $err . '</pre>';
			return array(0, 'مشکلی در تراکنش بوجود آمده است.');
		}
	  	  
		$parameters = array(
			'terminalId' => $terminalId,
			'userName' => $userName,
			'userPassword' => $userPassword,
			'orderId' => $orderId,
			'saleOrderId' => $settleSaleOrderId,
			'saleReferenceId' => $settleSaleReferenceId);

		// Call the SOAP method
		$result = $client->call('bpSettleRequest', $parameters, $namespace);

		// Check for a fault
		if ($client->fault) {
			echo '<h2>Fault</h2><pre>';
			print_r($result);
			echo '</pre>';
			return array(0, 'مشکلی در تراکنش بوجود آمده است.');
		} 
		else {
			$resultStr = $result;
			
			$err = $client->getError();
			if ($err) {
				// Display the error
				echo '<h2>Error</h2><pre>' . $err . '</pre>';
				//die();
				return array(0, 'مشکلی در تراکنش بوجود آمده است.');
			} 
			else {
				// Update Table, Save Settle Status 
				// Note: Successful Settle means that sale is settled.
				
			}// end Display the result
		}// end Check for errors
return array(1, ''); 
		}	
else{
return array(0, 'مشکلی در تراکنش بوجود آمده است.');
}
        
	}

	function showEndForm($pmconfigs, $order){
        
        $jshopConfig = &JSFactory::getConfig();        
	    /*$item_name = sprintf(_JSHOP_PAYMENT_PRODUCT_IN_SITE, $jshopConfig->store_name);*/
        $item_name = sprintf(_JSHOP_PAYMENT_NUMBER, $order->order_number);
        

            $host = "www.paypal.com";
       
        $terminal = $pmconfigs['terminal'];
		$muser = $pmconfigs['muser'];
		$mpass = $pmconfigs['mpass'];
        $notify_url = JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&js_paymentclass=pm_mellat&no_lang=1";
        $return = JURI::root(). "index.php?option=com_jshopping&controller=checkout&task=step7&act=return&orderid=".$order->order_id."&js_paymentclass=pm_mellat";
        $cancel_return = JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=pm_mellat";
        
        $_country = &JTable::getInstance('country', 'jshop');
        $_country->load($order->country);
        $country = $_country->country_code_2;
        
        ?>
        <html>
        <body>
        <head>
            <meta http-equiv="content-type" content="text/html; charset=utf-8" />            
        </head>
        <form id="paymentform" action="<?php echo JURI::base();?>components/com_jshopping/payments/pm_mellat/joominamellat.php" name = "paymentform" method = "post">
        <input name="terminalid" type="hidden" value="<?php echo $terminal; ?>"/>
        <input name="userName" type="hidden" value="<?php echo $muser; ?>"/>
        <input name="userPassword" type="hidden" value="<?php echo $mpass; ?>"/>      
        <input type='hidden' name='callback' value='<?php print $return?>'>
        <input type='hidden' name='item_number' value='<?php print $order->order_id?>'>
        <input type='hidden' name='PayAmount' value='<?php print round($order->order_total)?>'>
        </form>   
		
        <?php print _JSHOP_REDIRECT_TO_PAYMENT_PAGE ?>
        <br>
        <script type="text/javascript">document.getElementById('paymentform').submit();</script>
        </body>
        </html>
        <?php
        die();
	}
    
    function getUrlParams($pmconfigs){                        
        $params = array(); 
        $params['order_id'] = JRequest::getInt("orderid");
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = $pmconfigs['checkdatareturn'];
    return $params;
    }
    
}
?>